function [countBRISK,keypoints] = extractKeypointsBRISK(sceneImage, keypoints)
global pastImages

    scenePoints = detectBRISKFeatures(sceneImage, 'MinContrast', 0.05,'NumOctaves',1,'MinQuality',0.05);
    [sceneFeatures, scenePoints] = extractFeatures(sceneImage, scenePoints);
parfor i=1:size(pastImages,2)
    boxImage = pastImages(i).template;
    
    boxPoints = detectBRISKFeatures(boxImage, 'MinContrast', 0.05,'NumOctaves',1,'MinQuality',0.05);
    [boxFeatures, boxPoints] = extractFeatures(boxImage, boxPoints);
    boxPairs = matchFeatures(boxFeatures, sceneFeatures, 'MatchThreshold',15);
    
    if size(boxPairs,1)>4
        matchedBoxPoints = boxPoints(boxPairs(:, 1), :);
        matchedScenePoints = scenePoints(boxPairs(:, 2), :);
        try
            [~, ~, inlierScenePoints] = estimateGeometricTransform(matchedBoxPoints, matchedScenePoints, 'affine','Confidence',99,'MaxDistance',5.0);
            keypoints = [keypoints; inlierScenePoints.Location];
            countBRISK(i) = inlierScenePoints.Count;
        catch
            countBRISK(i) = 0;
        end
    else
%         display('not enough BRISK keypoints detected');
        countBRISK(i) = 0;
    end  
end