function [countFAST,keypoints] = extractKeypointsFAST(sceneImage, keypoints)
global pastImages

    scenePoints = detectFASTFeatures(sceneImage, 'MinContrast', 0.05,'MinQuality',0.05);
    [sceneFeatures, scenePoints] = extractFeatures(sceneImage, scenePoints);
parfor i=1:size(pastImages,2)
    boxImage = pastImages(i).template;
    
    boxPoints = detectFASTFeatures(boxImage, 'MinContrast', 0.05, 'MinQuality',0.05);
    [boxFeatures, boxPoints] = extractFeatures(boxImage, boxPoints);
    boxPairs = matchFeatures(boxFeatures, sceneFeatures, 'MatchThreshold',15);
    
    if size(boxPairs,1)>4
        matchedBoxPoints = boxPoints(boxPairs(:, 1), :);
        matchedScenePoints = scenePoints(boxPairs(:, 2), :);
        try
            [~, ~, inlierScenePoints] = estimateGeometricTransform(matchedBoxPoints, matchedScenePoints, 'affine','Confidence',99,'MaxDistance',5.0);
            keypoints = [keypoints; inlierScenePoints.Location];
            countFAST(i) = inlierScenePoints.Count;   
        catch
            countFAST(i) = 0;
        end
    else
%         display('not enough FAST keypoints detected');
        countFAST(i) = 0;
    end  
end