function [countSURF,keypoints] = extractKeypointsSURF(sceneImage, keypoints)
global pastImages

    scenePoints = detectSURFFeatures(sceneImage,'MetricThreshold',1,'NumScaleLevels',6,'NumOctaves',1);
    [sceneFeatures, scenePoints] = extractFeatures(sceneImage, scenePoints);
parfor i=1:size(pastImages,2)
    boxImage = pastImages(i).template;
    
    boxPoints = detectSURFFeatures(boxImage,'MetricThreshold',1,'NumScaleLevels',6,'NumOctaves',1);
    [boxFeatures, boxPoints] = extractFeatures(boxImage, boxPoints);
    boxPairs = matchFeatures(boxFeatures, sceneFeatures, 'MatchThreshold',15);
    
    if size(boxPairs,1)>4
        matchedBoxPoints = boxPoints(boxPairs(:, 1), :);
        matchedScenePoints = scenePoints(boxPairs(:, 2), :);
        try
            [~, ~, inlierScenePoints] = estimateGeometricTransform(matchedBoxPoints, matchedScenePoints, 'affine','Confidence',99,'MaxDistance',5.0);
            keypoints = [keypoints; inlierScenePoints.Location];
            countSURF(i) = inlierScenePoints.Count;
        catch
            countSURF(i) = 0;
        end
    else
%         display('not enough SURF keypoints detected');
        countSURF(i) = 0;
    end  
end