function [bbox,score] = histTracker(oldBbox,oldFrameB,frameB)
% This function detects the bounding box using the object region of the
% last frame. 

% first rezise the oldBbox and oldFrameB to the size of frameB
try    
    xScale = (size(oldFrameB,2)-size(frameB,2))/size(oldFrameB,2);
    yScale = (size(oldFrameB,1)-size(frameB,1))/size(oldFrameB,1);
    if xScale>0
        xScale = 1-xScale;
    else
        xScale = 1+xScale;
    end
    if yScale>0
        yScale = 1-yScale;
    else
        yScale = 1+yScale;
    end
    oldBbox(1)=round(oldBbox(1)*xScale); oldBbox(3)=round(oldBbox(3)*xScale); 
    oldBbox(2)=round(oldBbox(2)*yScale); oldBbox(4)=round(oldBbox(4)*yScale);
    oldFrameB = imresize(oldFrameB,[size(frameB,1), size(frameB,2)]);

    objectHSV = rgb2hsv(oldFrameB);
    tracker = vision.HistogramBasedTracker;
    initializeObject(tracker, objectHSV(:,:,1) , oldBbox);
    hsv = rgb2hsv(frameB);                   
    % bbox = tracker(hsv(:,:,1)); 
    [bbox,~,score] = step(tracker, hsv(:,:,1)); %[BBOX, ORIENTATION, SCORE]
catch
    score = 0;
    bbox = nan;
end
end