function [bbox,pointCount] = pointTracker(frameB,tracker,oldPoints,oldBbox)
% This function detects the object using the tracker initialized only using
% the 1st frame.

[points,validity] = tracker(frameB);
visiblePoints = points(validity, :);
oldInliers = oldPoints.Location(validity, :);
pointCount = size(visiblePoints,1);
if 3<pointCount
    try
        [xform,~,~] = pointTrackerGeoTran(oldInliers, visiblePoints); % mex file
        bboxPoints = bbox2points(oldBbox(1, :));
        bboxPoints = transformPointsForward(xform, bboxPoints);
        bboxPolygon = reshape(bboxPoints', 1, []);

        x1 = round(min(bboxPolygon(1:2:end)));
        x2 = round(max(bboxPolygon(1:2:end)));
        y1 = round(min(bboxPolygon(2:2:end)));
        y2 = round(max(bboxPolygon(2:2:end)));
        bbox = round([x1, y1, x2 - x1, y2 - y1]);
        bbox = adjustBbox(bbox,size(frameB,2),size(frameB,1)); % change bbox for out of image cordinates
    catch
        bbox = nan;
    end
else
    bbox = nan;
end
end
