function bboxTYPE = pointTrackerNewTYPE(boxPoints,scenePoints,boxPairs,boxImageSize)

matchedBoxPoints = boxPoints(boxPairs(:, 1), :);
matchedScenePoints = scenePoints(boxPairs(:, 2), :);
try
    [tform, ~, ~] = estimateGeometricTransform(matchedBoxPoints, matchedScenePoints, 'similarity','Confidence',99,'MaxDistance',5.0);

    % Get the bounding polygon of the reference image.
    boxPolygon = [1, 1; boxImageSize(2), 1; boxImageSize(2), boxImageSize(1); 1, boxImageSize(1); 1, 1];

    newBoxPolygon = transformPointsForward(tform, boxPolygon);    

    xmin = min(newBoxPolygon(:,1));
    ymin = min(newBoxPolygon(:,2));
    xmax = max(newBoxPolygon(:,1));
    ymax = max(newBoxPolygon(:,2));
    bboxTYPE = [xmin, ymin, (xmax-xmin), (ymax-ymin)];
catch
    bboxTYPE = [0, 0, 0, 0];
end

        